<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlarmScreenNg: Alarm properties</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlarmScreenNg
   &#160;<span id="projectnumber">0.9.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
    </ul>
  </div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="page_References.html">References</a></li>  </ul>
</div>
</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Alarm properties </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>The alarms, stored in AS EWO, can be read by CTRL code, the alarms are returned as CTRL data type <code>mapping</code>, with keys of type <code>string</code>. Every key in alarm mapping corresponds to the property of alarm.</p>
<p>This sections describes the names of alarm properties in AS EWO, meaning and format of property values.</p>
<h1><a class="anchor" id="sec_RefAlarmPropBasic"></a>
Basic properties</h1>
<p>This set of alarm properties is provided by the 'basic' AS EWO, without any extension <a class="el" href="page_RefJson.html#subsubsec_RefJsonBasicConfigAlarmModel">plugins</a>. All basic properties fall into one of two major categories: </p><ul>
<li>
Alarm properties, containing the value of one of attributes of <b>_alert_hdl</b> config of DPE  </li>
<li>
Other properties  </li>
</ul>
<p>All names of basic alarm properties are declared as cosntants ALARM_PROP_xxx in CTRL library AlarmScreenNg.ctl.</p>
<h2><a class="anchor" id="subsec_RefAlarmPropBasicAlertHdl"></a>
Attributes of _alert_hdl config</h2>
<p>These alarm properties are listed in table, together with corresponding attribute of <b>_alert_hdl</b> config and the 'native' data type for the value of this property. More information on every particular attribute can be found in WinCC OA help.</p>
<table class="markdownTable">
<tr class="markdownTableHead">
<th class="markdownTableHeadRight">Property name   </th><th class="markdownTableHeadRight">Attribute of _alert_hdl   </th><th class="markdownTableHeadLeft">Data type    </th></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">Abbreviation   </td><td class="markdownTableBodyRight">_abbr   </td><td class="markdownTableBodyLeft">string    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">AckOblig   </td><td class="markdownTableBodyRight">_ack_oblig   </td><td class="markdownTableBodyLeft">bool    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">AckType   </td><td class="markdownTableBodyRight">_ack_type   </td><td class="markdownTableBodyLeft">int    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">AckState   </td><td class="markdownTableBodyRight">_ack_state   </td><td class="markdownTableBodyLeft">int    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">AckTime   </td><td class="markdownTableBodyRight">_ack_time   </td><td class="markdownTableBodyLeft">time    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">Ackable   </td><td class="markdownTableBodyRight">_ackable   </td><td class="markdownTableBodyLeft">bool    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">AlertColor   </td><td class="markdownTableBodyRight">_alert_color   </td><td class="markdownTableBodyLeft">string    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">AlertFontStyle   </td><td class="markdownTableBodyRight">_alert_font_style   </td><td class="markdownTableBodyLeft">string    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">AlertForeColor   </td><td class="markdownTableBodyRight">_alert_fore_color   </td><td class="markdownTableBodyLeft">string    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">AlarmId   </td><td class="markdownTableBodyRight">_alert_id   </td><td class="markdownTableBodyLeft">string    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">Comment   </td><td class="markdownTableBodyRight">_comment   </td><td class="markdownTableBodyLeft">string    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">Destination   </td><td class="markdownTableBodyRight">_dest   </td><td class="markdownTableBodyLeft">int    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">Direction   </td><td class="markdownTableBodyRight">_direction   </td><td class="markdownTableBodyLeft">bool    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">Filtered   </td><td class="markdownTableBodyRight">_filtered   </td><td class="markdownTableBodyLeft">bool    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">ForceFiltered   </td><td class="markdownTableBodyRight">_force_filtered   </td><td class="markdownTableBodyLeft">bool    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">MultiInstance   </td><td class="markdownTableBodyRight">_multi_instance   </td><td class="markdownTableBodyLeft">bool    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">Obsolete   </td><td class="markdownTableBodyRight">_obsolete   </td><td class="markdownTableBodyLeft">bool    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">OldestAck   </td><td class="markdownTableBodyRight">_oldest_ack   </td><td class="markdownTableBodyLeft">bool    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">Panel   </td><td class="markdownTableBodyRight">_panel   </td><td class="markdownTableBodyLeft">string    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">PanelParam   </td><td class="markdownTableBodyRight">_panel_param   </td><td class="markdownTableBodyLeft">dyn_string    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">PartnerTime   </td><td class="markdownTableBodyRight">_partner   </td><td class="markdownTableBodyLeft">time    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">PartnerTimeIdx   </td><td class="markdownTableBodyRight">_partn_idx   </td><td class="markdownTableBodyLeft">int    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">Priority   </td><td class="markdownTableBodyRight">_prior   </td><td class="markdownTableBodyLeft">uint    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">Sum   </td><td class="markdownTableBodyRight">_sum   </td><td class="markdownTableBodyLeft">bool    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">Text   </td><td class="markdownTableBodyRight">_text   </td><td class="markdownTableBodyLeft">string    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">Value   </td><td class="markdownTableBodyRight">_value   </td><td class="markdownTableBodyLeft">data type of DPE    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">Visible   </td><td class="markdownTableBodyRight">_visible   </td><td class="markdownTableBodyLeft">bool   </td></tr>
</table>
<h2><a class="anchor" id="subsec_RefAlarmPropBasicOther"></a>
Other basic properties</h2>
<p>Other basic properties of alarm can be sundivided into two categories. First catogory includes properties whose values are calculated as a result of decomposition of <code>atime</code>, see WinCC OA help on this data type.</p>
<table class="markdownTable">
<tr class="markdownTableHead">
<th class="markdownTableHeadRight">Property name   </th><th class="markdownTableHeadLeft">Data type   </th><th class="markdownTableHeadLeft">Description    </th></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">SystemName   </td><td class="markdownTableBodyLeft">string   </td><td class="markdownTableBodyLeft">The name of system where DP of alarm is located    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">DataPointName   </td><td class="markdownTableBodyLeft">string   </td><td class="markdownTableBodyLeft">The name of DP where alarm came from, without DPE, config and attribute    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">ElementName   </td><td class="markdownTableBodyLeft">string   </td><td class="markdownTableBodyLeft">The name of DPE where alarm came from, without config and attribute    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">AlarmTime   </td><td class="markdownTableBodyLeft">time   </td><td class="markdownTableBodyLeft">Time when alarm occured    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">Index   </td><td class="markdownTableBodyLeft">int   </td><td class="markdownTableBodyLeft">Index for ordering alarms which occured within 1 msec time interval    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyRight">FullAlarmDpe   </td><td class="markdownTableBodyLeft">string   </td><td class="markdownTableBodyLeft">Full name of DPE where alarm came from, including config and attribute    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyRight">dpElement   </td><td class="markdownTableBodyLeft">string   </td><td class="markdownTableBodyLeft">Pure DPE name, without system name, config and attribute   </td></tr>
</table>
<p>Second category of 'other' alarm properties: properties, calculated from other properties, or even something hardcoded, used for special purposes.</p>
<table class="doxtable">
<tr>
<th>Property name </th><th>Data type </th><th>Description  </th></tr>
<tr>
<td>AckStateSummary </td><td>int </td><td>Calculated 'summary' of acknowldgement state for this alarm. This corresponds to famous strings "!!!", "xxx" etc. in table column "Ack.". The value is introduced for use in CTRL code (if needed): analysing integer (enumerated) value seems to be more convenient than analyzing strings, displayed in table column. Possible values of this property are declared as ALARM_ACK_STATE_SUMMARY_xxx constants in CTRL library AlarmScreenNg.ctl   </td></tr>
<tr>
<td>nofComments</td><td>int </td><td>Number of comments for alarm, calculated by parsing the value of "Comment" property, corresponding to <b>_alert_hdl._comment</b> attribute.   </td></tr>
<tr>
<td>ThisToAck</td><td>bool </td><td>This and next properties are calculated for very special purpose: acknowledgement of multiple alarms from table. It can happen that one alarm of pair is known to AS EWO, but partner alarm is not known (for example, because of filtering at low level of model).<br  />
 If in such situation request to 'acknowledge all' arrives (and the method of AS EWO <a class="el" href="page_RefEwo.html#sec_RefEwoMethodsConnect">getForAcknowledgementAll()</a> is called), then EWO doesn't know if partner shall be acknowledged or not.<br  />
 In such case, AS EWO returns this alarm, where property <b>NoPartnerData</b> is set to <code>true</code> (see next line in this table). Then it is responsability of CTRL code, perfroming ackowledgement, to read details of partner alarm and decide if that partner shall be acknowledged or not.<br  />
 <b>ThisToAck</b> property (if <code>true</code>) indicates that <b>this</b> alarm does not need acknowldgement, the alarm is only retuirned by EWO's method in order to allow for CTRL code to find partner alarm and make a adecision on partner's acknowledgement.<br  />
 See example of using this (and next) property in function AlarmScreenNg_checkForPartnersToAck(), defined in CTRL library AlarmScreenNg.ctl.   </td></tr>
<tr>
<td>NoPartnerData</td><td>bool </td><td>When <code>true</code> indicates that AS EWO doesn't know if partner of this alarm shall be acknowledged or not. See also description of <b>ThisToAck</b> property above.   </td></tr>
<tr>
<td>Details</td><td>string </td><td><p class="starttd">This property doesn't contain useful information, the content is always string "...". The property was introduced for special column in Alarm Table: </p><div class="image">
<img src="detailsColumn.png" alt=""/>
<div class="caption">
Special column</div></div>
 <p class="intertd">Clicking on cell in this column with left mouse button opens (by default) panel with alarm details. In fact, this property just provides some content for column where user can click with mouse.  </p>
<p class="endtd"></p>
</td></tr>
</table>
<h1><a class="anchor" id="sec_RefAlarmPropJCOP"></a>
JCOP-specific properties</h1>
<p>As descibed in configuration of <a class="el" href="page_RefJson.html#subsubsec_RefJsonBasicConfigAlarmModel">Alarm Model</a>, AS EWO supports using plugins, which can extend set of alarm properties. This section describes alarm properties, added by plugin for JCOP (corresponding DLL is named <b>AlarmPropJCOP</b>).</p>
<p>The names of alarm properties, added by this plugin, are declared as constants ALARM_PROP_JCOP_xxx in CTRL library AlarmScreenJCOP.ctl.</p>
<dl class="section note"><dt>Note</dt><dd>When using these names of properties in CTRL code to access the values in <code>mapping</code> with alarm data, do not make an assumption that properties are always there: the name may be missing in mapping if corresponding value is empty.</dd></dl>
<table class="doxtable">
<tr>
<th>Property name </th><th>Data type </th><th>Description  </th></tr>
<tr>
<td>alias </td><td>string </td><td>Alias of DP where alarm came from  </td></tr>
<tr>
<td>deviceDescription</td><td>string </td><td>Description of DP where alarm came from: either comment for DP, or comment for DPE if comment for DP is empty   </td></tr>
<tr>
<td>onlineValue</td><td>string </td><td>The string with alarm value, formatted using format and units, specified in alarm DPE   </td></tr>
<tr>
<td>cameTime</td><td>time </td><td>The time of CAME alarm of alarms pair. If this alarm is CAME, then it is time of this alarm, otherwise this is time of partner alarm.   </td></tr>
<tr>
<td>deviceType</td><td>string </td><td>The name of device type for DP where alarm came from. Device type is not contained directly in DP/DPE, but rather some indirect calculation is used: <ul>
<li>
The definition of device types, configured for JCOP, are stored in internal DPs of type <b>_FwDeviceDefinition</b>  </li>
<li>
Every DP of such type has (among others) DPes: <ul>
<li>
<b>dpType</b>: the name of DP type </li>
<li>
<b>type</b>: the name of JCOP device type for this DP type </li>
</ul>
</li>
<li>
Thus, the calculation of device type is done in two steps: first find the name of DP type for DP where alarm came from; then find corresponding name of JCOP device type.  </li>
</ul>
<dl class="section note"><dt>Note</dt><dd>For performance reasons, the mapping of DP types to JCOP device types is only read once by this plugin.   </dd></dl>
</td></tr>
<tr>
<td>scope</td><td>string </td><td>Simple string, calculated from alarm priority using relatively simple algorithm: <ul>
<li>
<b>Local</b>: alarms with prioritiy in ranges: [40...49], [60...69], [80...89]  </li>
<li>
<b>Gloabl</b>: alarms with priority in ranges: [50...69], [70...79], [90...255]  </li>
<li>
<b>Local-Global</b>: alarms with priority 1 </li>
</ul>
</td></tr>
</table>
<h1><a class="anchor" id="sec_RefAlarmPropUNICOS"></a>
UNICOS-specific properties</h1>
<p>As descibed in configuration of <a class="el" href="page_RefJson.html#subsubsec_RefJsonBasicConfigAlarmModel">Alarm Model</a>, AS EWO supports using plugins, which can extend set of alarm properties. This section describes alarm properties, added by plugin for UNICOS (corresponding DLL is named <b>AlarmPropUNICOS</b>).</p>
<p>The names of alarm properties, added by this plugin, are declared as constants ALARM_PROP_UN_xxx in CTRL library AlarmScreenUNICOS.ctl.</p>
<dl class="section note"><dt>Note</dt><dd>When using these names of properties in CTRL code to access the values in <code>mapping</code> with alarm data, do not make an assumption that properties are always there: the name may be missing in mapping if corresponding value is empty.</dd></dl>
<table class="doxtable">
<tr>
<th>Property name </th><th>Data type </th><th>Description  </th></tr>
<tr>
<td>alias </td><td>string </td><td>Alias of DP where alarm came from  </td></tr>
<tr>
<td>timeUtc</td><td>time </td><td>Alarm time converted to UTC time  </td></tr>
<tr>
<td>application</td><td>string </td><td>The name of UNICOS application, extracted from DP name. DP name is supposed to be built of parts, separated by <b>-</b> character; the application name is part #2.   </td></tr>
<tr>
<td>deviceType</td><td>string </td><td>The name of UNICOS device type, extracted from DP name. DP name is supposed to be built of parts, separated by <b>-</b> character; the device type name is part #3.   </td></tr>
<tr>
<td>alias</td><td>string </td><td>Alias of DPE where alarm came from.  </td></tr>
<tr>
<td>domain</td><td>string </td><td>The domain of UNICOS device, extracted from DP comment. The comment is supposed to be built of parts separated by <b>~</b> character; the domain name if part #0.   </td></tr>
<tr>
<td>nature</td><td>string </td><td>The nature of UNICOS device, extracted from DP comment. The comment is supposed to be built of parts separated by <b>~</b> character; the nature if part #1.   </td></tr>
<tr>
<td>description</td><td>string </td><td>The description of UNICOS device, extracted from DP comment. The comment is supposed to be built of parts separated by <b>~</b> character; the description if part #3.   </td></tr>
<tr>
<td>alarmType</td><td>string </td><td>The 'official' name of alarm type. For DPs of types CPC_AnalogAlarm and CPC_DigitalAlarm, the value is calculated by parsing the value of DPE *.statusInformation.configuration.deviceConfiguration: in string like 'TYPE:TS:QRLIC_07L3_CV998' the alarm type is second part (TS in this example). For other DP types, the value extracted from DP comment. The comment is supposed to be built of parts separated by <b>~</b> character; the name if part #4.   </td></tr>
<tr>
<td>master</td><td>string </td><td>The name of 'master' device, only used for DPs of type CPC_AnalogAlarm and CPC_DigitalAlarm. The value is calculated by parsing the value of DPE *.statusInformation.configuration.deviceConfiguration: in string like 'TYPE:TS:QRLIC_07L3_CV998' the alarm type is last part (QRLIC_07L3_CV998 in this example).   </td></tr>
<tr>
<td>alarmLevel</td><td>int/string </td><td>The level of alarm, only used for DPs of type CPC_AnalogAlarm and CPC_DigitalAlarm. The value is calculated by parsing the value of DPE *.statusInformation.configuration.deviceConfiguration: in string like 'ALARM_LEVEL:2' the resulting alarm level is 2. The following meaning of levels is used: <ul>
<li>
0 = Info </li>
<li>
1 = Warning </li>
<li>
2 = Alarm </li>
<li>
3 = Safety alarm </li>
</ul>
</td></tr>
<tr>
<td>unPanel</td><td>string </td><td>The name of panel, designed to display detailed information for this UNICOS device (faceplate). Panel name is xtracted from DP comment. The comment is supposed to be built of parts separated by <b>~</b> character; the panel name if part #5.   </td></tr>
<tr>
<td>s</td><td>string </td><td>property to provide visible indication (in table) for existence of faceplate for this device. The rule for calculating this property is: the value is string "S" if the value of <b>unPanel</b> property is not empty, otherwise the value of this property is empty. Column with this property is used in Alarm Table for opening device faceplate when left mouse button is clicked on cell with "S'.   </td></tr>
</table>
<dl class="section note"><dt>Note</dt><dd>JCOP and UNICOS plugins use the name names ("alias" and "deviceType") with different meaning. If both plugins are used in the same <a class="el" href="page_RefJson.html#subsubsec_RefJsonBasicConfigAlarmModel">model configuration</a>, then the last one wins. </dd></dl>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
